#include "tricks.h"
#include <fstream.h>

byte buffer[64000];
byte bumpmap[64000];
byte envmap[65536];

float lightx, lighty;

void main()
{
   ifstream bump( "..\\data\\bumpmap.raw", ios::binary );
   bump.read( bumpmap, 64000); 

   if( bump.fail() )
   {
      cout << "error reading bumpmap.raw" << endl;
      return;
   }

   bump.close();

   for( int i=0; i<256; i++)
      for( int j=0; j<256; j++)
      {
         unsigned int col = 256-sqrt( ((i<<1)-256)*((i<<1)-256)
                                    + ((j<<1)-256)*((j<<1)-256) );

         if( col<256)
            envmap[ (i<<8) + j ] = (byte) col;
      }

   envmap[ 128*256 + 128 ] = 255;
   
   GrabPallette();
   SetMCGA();
   for( i=0; i<256; i++)
      Pal( i, 0, i>>2, i>>2 );    

   float sinus = sin(-0.1);
   float cosin = cos(-0.1);

   lightx = 50;
   lighty = 50;

   do
   {
      float tmp = lightx*cosin + lighty*sinus;
      lighty = lighty*cosin - lightx*sinus;
      lightx = tmp;
                       
      int lx, ly;
      int xd, yd;
   
      register byte *src = bumpmap + 320;
      register byte *dst = buffer;

      ly = -lighty + 27; // (-100 + 127)

      for( int i=1; i<199; i++, ly++)
      {
         lx = -lightx - 33; // (-160 + 127)

         for( int j=0; j<320; j++, src++, lx++)
         {
            xd = ((src[-1] - src[1]) >> 1) + lx;
            yd = ((src[-320] - src[320]) >> 1) + ly;

            if((xd & 0xFFFFFF00) || (yd & 0xFFFFFF00))
               *dst++ = 0;
            else
               *dst++ = envmap[(xd<<8)+yd];
         }
      }

//      Pal(0,0,0,0);
      WaitRetrace();
//      Pal(0,30,0,0);

      int *v= (int*) vga;
      int *b= (int*) buffer;
   
      for( i=0; i<16000; i++)
         *v++ = *b++;

   } while (!kbhit());

   getch();
   SetText();
   RestorePallette();
}
